#include <cmath>
#include <fstream>

using namespace std;


constexpr double pi = 3.1415926;
constexpr double me = 9.10938356e-31;
constexpr double ma = 1.66053904e-27;
constexpr double h = 6.62607004e-34;
constexpr double c = 299792458.0;
constexpr double G = 6.67408e-11;
constexpr double mue = 2.15; //mue = 2.15, ӵƽ
constexpr double lambda = h / (2. * pi * me * c);
constexpr double lambda_3 = lambda * lambda * lambda;
constexpr double K_1 = me * c * c / lambda_3;
constexpr double K_2 = ma * mue / (3. * pi * pi * lambda_3);
constexpr double K = 9. * pi * pi * K_2 * K_2 * G / K_1;

constexpr double dr = 100.0; // dr Ϊÿλֵĳ

struct MR
{
    double m;
    double r;
    double rho;
};

MR calculate_one_rho(double rho_center){
    double m = 0.;
    double r = 0.;
    double rho = rho_center;
    double x;
    while(rho > 0.)
    {
        x = pow(rho / K_2, 1./3.);
        r += dr;
        m += 4. * pi * r * r * rho * dr;
        rho += -K * x * sqrt(1.+x*x) * m / (r * r) * dr;
    }
    return MR{m, r, rho};
}

int main(int argc, char const *argv[])
{
    MR result[100];
    for(int i=0; i<100; ++i)
    {
        result[i] = calculate_one_rho(exp(i/4.) * 1e8);
    }

    ofstream ofs("data.txt");
    for(int i=0; i<100; ++i)
    {
        ofs << result[i].rho << ',' << result[i].m << ',' << result[i].r << '\n';
    }
    ofs.close();
    return 0;
}
